
var Transform = require('./streamwrapper').Transform;
var genKey = require('./utilities').genKey;
var genKeys = require('./utilities').genKeys;
var defs = require('./utilities').defs;

function genActions(triple) {
  var json = JSON.stringify(triple)
    , keys = genKeys(triple)
    , i
    , result = [];

  for (i = 0; i < keys.length; i++) {
    result.push({ key: keys[i], value: json });
  }

  return result;
}

function WriteStream(options) {
  if (!(this instanceof WriteStream)) {
    return new WriteStream(options);
  }

  options = options || {};
  options.objectMode = true;

  Transform.call(this, options);
}

WriteStream.prototype = Object.create(
  Transform.prototype,
  { constructor: { value: WriteStream } }
);

WriteStream.prototype._transform = function(data, encoding, done) {
  var that = this, i, actions = genActions(data);

  for (i = 0; i < actions.length; i++) {
    that.push(actions[i]);
  }

  done();
};

module.exports = WriteStream;
